#!/usr/bin/env gosh

(use dbi)
(use file.util)
(use gauche.parameter)
(use srfi-13)
(use typo.dbi)

(define typo-migrate-directory (make-parameter "/home/tabe/work/typo/db/migrate"))

(define conn (make-parameter #f))

(define (create-table name . rest)
  (unless (= 0 (typo-dbi-count (conn) "information_schema.tables" :table_schema "public" :table_name name))
    (typo-dbi-drop-table (conn) name))
  (apply typo-dbi-create-table (conn) name rest))

(define (main args)
  (conn (dbi-connect "dbi:pg:dbname=typo;host=localhost;port=5432" :username "tabe"))
  (directory-fold
   (typo-migrate-directory)
   (lambda (entry seed)
     (cond ((string-suffix? ".scm" entry)
            (print entry)
            (call-with-input-file entry
              (lambda (iport)
                (let lp ((s (read iport)))
                  (cond ((eof-object? s)
                         #t)
                        (else
                         (eval s (interaction-environment))
                         (lp (read iport))))))))
           (else
            seed)))
   '())
  0)
