(define-module daemon
  (use gauche.parameter)
  (export daemon-pid-file
          daemonize)
  )

(select-module daemon)

(define daemon-pid-file (make-parameter #f))

(define (daemonize)
  (call/cc
   (lambda (cont)
     (when (= 1 (sys-getppid)) (cont #f))
     (let ((pid (sys-fork)))
       (when (< pid 0) (cont #f))
       (when (< 0 pid)
         (when (daemon-pid-file)
           (call-with-output-file (daemon-pid-file) (cut display pid <>)))
         (sys-exit 0))
       )
     ;; child process
     (guard (e
             (else (exit 1)))
       (sys-umask 0)
       (sys-setsid)
       (sys-chdir "/")
       (call-with-input-file "/dev/null"
         (cut port-fd-dup! (current-input-port) <>))
       (call-with-output-file "/dev/null"
         (lambda (oport)
           (port-fd-dup! (current-output-port) oport)
           (port-fd-dup! (current-error-port) oport)))
       ))))

(provide "daemon")
