(define-module lang.swi-prolog
  (use srfi-13)
  (use text.tree)
  (use util.list)
  (export
   x->term
   alist->term
   ))

(select-module lang.swi-prolog)

(define-method x->term ((b <boolean>))
  (if b 'true 'false))

(define-method x->term ((n <number>))
  n)

(define-method x->term ((str <string>))
  (format #f "'~a'"
          (regexp-replace-all*
           str
           #/\\/ "\\\\\\\\"
           #/'/ "\\\\'"
           #/\f/ "\\\\f"
           #/\n/ "\\\\n"
           #/\r/ "\\\\r"
           #/\t/ "\\\\t"
           )))

(define (alist->term alist)
  (let ((ls (map
             (lambda (pair)
               (format #f "~a(~a)" (car pair) (x->term (cdr pair))))
             alist)))
    (tree->string `(#\[ ,@(intersperse #\, ls) #\]))))

(provide "lang/swi-prolog")
