(define-module sendmail
  (use gauche.parameter)
  (use gauche.process)
  (use gauche.charconv)
  (export sendmail-path
          sendmail-sender
          sendmail)
  )

(select-module sendmail)

(define sendmail-path (make-parameter "/usr/sbin/sendmail"))
(define sendmail-sender (make-parameter #f))

(define (sendmail to from subject body)
  (call-with-output-process
   (string-append (format #f "~a -t -oi" (sendmail-path))
                  (if (sendmail-sender) (format #f " -f~a" (sendmail-sender)) ""))
   (lambda (oport)
     (format oport "To: ~a~%" to)
     (format oport "From: ~a~%" from)
     (format oport "Subject: ~a~%" subject)
     (format oport "Content-Transfer-Encoding: 7bit~%")
     (format oport "Content-Type: text/plain; charset=ISO-2022-JP~%")
     (newline oport)
     (display (ces-convert body "utf8" "iso2022jp") oport)
     #t)))

(provide "sendmail")
