(define-module typo.dbi
  (use dbi)
  (use typo.sql)
  (use util.relation)
  (export
   typo-dbi-select
   typo-dbi-count
   typo-dbi-insert
   typo-dbi-update
   typo-dbi-delete
   typo-dbi-nextval
   typo-dbi-create-table
   typo-dbi-drop-table
   typo-dbi-close
   ))

(select-module typo.dbi)

(define-syntax define-with-sql
  (syntax-rules ()
    ((_ name procedure)
     (define (name conn table . args)
       (call-with-values
           (cut apply procedure table args)
         (cut apply dbi-do conn <> '() <>))))))

(define-with-sql typo-dbi-select typo-sql-select)
(define-with-sql typo-dbi-insert typo-sql-insert)
(define-with-sql typo-dbi-update typo-sql-update)
(define-with-sql typo-dbi-delete typo-sql-delete)
(define-with-sql typo-dbi-nextval typo-sql-nextval)
(define-with-sql typo-dbi-create-table typo-sql-create-table)
(define-with-sql typo-dbi-drop-table typo-sql-drop-table)

(define (typo-dbi-count conn table . args)
  (call-with-values
      (cut apply typo-sql-count table args)
    (lambda (x y)
      (let* ((result (apply dbi-do conn x '() y))
             (getter (relation-accessor result)))
        (begin0
          (string->number (getter (ref result 0) "count"))
          (dbi-close result))))))

(define (typo-dbi-close result)
  (dbi-close result))

(provide "typo/dbi")
