(define-module typo.script
  (extend typo)
  (use file.util)
  (use gauche.parameter)
  (use text.inflection)
  (use util.list)
  (export
   typo-script-aws-keyword-file
   typo-script-aws-keyword-on
   typo-script-aws-keyword-off
   typo-script-aws-dasherize
   ))

(select-module typo.script)

(define typo-script-aws-keyword-file (make-parameter #f))

(define typo-script-aws-keyword-parameter (make-parameter #f))

(define (typo-script-aws-keyword-on)
  (let ((alist (file->sexp-list (typo-script-aws-keyword-file) :if-does-not-exist #f)))
    (typo-script-aws-keyword-parameter
     (alist->hash-table
      (if alist (map (lambda (pair) (cons (x->string (car pair)) (x->string (cdr pair)))) alist) '())
      'string=?))))

(define (typo-script-aws-keyword-off)
  (call-with-output-file (typo-script-aws-keyword-file)
    (lambda (oport)
      (for-each
       (cut format oport "~s~%" <>)
       (map (lambda (pair) (cons (string->symbol (car pair)) (string->symbol (cdr pair))))
            (hash-table->alist (typo-script-aws-keyword-parameter #f))))))
  #f)

(define (typo-script-aws-dasherize x)
  (let ((dashed (dasherize x)))
    (cond ((hash-table-get (typo-script-aws-keyword-parameter) dashed #f)
           => (lambda (y)
                (if (string-ci=? x y)
                    dashed
                    (error "afraid of duplicate keys:" (list x y)))))
          (else
           (hash-table-put! (typo-script-aws-keyword-parameter) dashed x)
           dashed))))

(provide "typo/script")
