#!/usr/bin/env gosh

(use aws)
(use rfc.http)
(use srfi-13)
(use sxml.ssax)
(use sxml.sxpath)
(use typo.script)

(define *response-elements*
  (aws-developer-guide "/CHAP_ApiReference.html"))

(define *namespace*
  '((fo . "http://www.w3.org/1999/XSL/Format")
    (xhtml . "http://www.w3.org/1999/xhtml")))

(define (main args)
  (typo-script-aws-keyword-file (cadr args))
  (typo-script-aws-keyword-on)
  (receive (code headers body)
      (http-get *aws-documentation-host-name* *response-elements*)
    (cond ((string-prefix? "2" code)
           (call-with-input-string body
             (lambda (iport)
               (let ((sxml (ssax:xml->sxml iport *namespace*))
                     (query (sxpath '(// (xhtml:div (@ (equal? (class "informaltable")))) xhtml:table xhtml:tbody xhtml:tr)))
                     )
                 (for-each
                  (lambda (row)
                    (let* ((tds ((sxpath '(// xhtml:td)) row))
                           (element (string->symbol (typo-script-aws-dasherize (string-trim-both (car ((sxpath '(// *data*)) (car tds)))))))
                           (description ((sxpath '(// *data*)) (cadr tds))))
                      (format (current-output-port) "(~s~%" element)
                      (for-each
                       (cut format (current-output-port) " ~s~%" <>)
                       description)
                      (print ")")))
                  (query sxml)
                  )))))
          (else
           (error "http failure:" code)
           )))
  (typo-script-aws-keyword-off)
  0)
