#!/usr/bin/env gosh

(use aws)
(use rfc.http)
(use srfi-13)
(use sxml.ssax)
(use sxml.sxpath)
(use typo.script)

(define (sort-values-article locale)
  (aws-developer-guide (format #f "/~aSortValuesArticle.html" (string-upcase (x->string locale)))))

(define *namespace*
  '((fo . "http://www.w3.org/1999/XSL/Format")
    (xhtml . "http://www.w3.org/1999/xhtml")))

(define (main args)
  (for-each
   (lambda (locale)
     (receive (code headers body)
         (http-get *aws-documentation-host-name* (sort-values-article locale))
       (cond ((string-prefix? "2" code)
              (format (current-output-port) "(~a ; ----------------------------------------------------------------------~%" locale)
              (call-with-input-string body
                (lambda (iport)
                  (let ((sxml (ssax:xml->sxml iport *namespace*))
                        (q-tbody (sxpath '(// xhtml:div xhtml:table xhtml:tbody)))
                        (q-h2 (sxpath '(// xhtml:h2 xhtml:a @ id)))
                        )
                    (for-each
                     (lambda (h2 tbody)
                       (format (current-output-port) " (~a~%" (string-downcase (cadr (string-split (cadr h2) #\_))))
                       (for-each
                        (lambda (tr)
                          (format (current-output-port) "  ~s~%" (list (string->symbol (cadr (cadr tr)))
                                                                       (cadr (caddr tr)))))
                        (cdr tbody))
                       (print "  )")
                       )
                     (cdr (q-h2 sxml))
                     (q-tbody sxml)
                     ))))
              (print ")")
              )
             (else
              (error "http failure:" code)
             ))))
   *aws-locales*)
  0)
