%% -*- coding: utf-8 -*-
:- module(isbn,[isbn/4]).
:- encoding(utf8).

digit(D,N) -->
    [D],
    { char_type(D,digit),
      number_chars(N,[D]) }.

isbn_digit(D,N) --> ([-];[]),!,digit(D,N).
isbn10_check_digit('0',11) --> ([-];[]),['0'],!.
isbn10_check_digit('X',10) --> ([-];[]),['X'],!.
isbn10_check_digit(D,N) --> isbn_digit(D,N).

isbn(13,[A,B,C,D,E,F,G,H,I,J,K,L,M]) -->
    (['I','S','B','N'],! ; []),
    isbn_digit(A,N0),isbn_digit(B,N1),isbn_digit(C,N2),
    isbn_digit(D,N3),isbn_digit(E,N4),isbn_digit(F,N5),
    isbn_digit(G,N6),isbn_digit(H,N7),isbn_digit(I,N8),
    isbn_digit(J,N9),isbn_digit(K,N10),!,isbn_digit(L,N11),isbn_digit(M,N12),
    { N12 is (10 - ((N0*1+N1*3+N2*1+N3*3+N4*1+N5*3+N6*1+N7*3+N8*1+N9*3+N10*1+N11*3) mod 10)) mod 10 }.
isbn(10,[A,B,C,D,E,F,G,H,I,J]) -->
    ( ['I','S','B','N'],! ; []),
    isbn_digit(A,N0),isbn_digit(B,N1),isbn_digit(C,N2),
    isbn_digit(D,N3),isbn_digit(E,N4),isbn_digit(F,N5),
    isbn_digit(G,N6),isbn_digit(H,N7),isbn_digit(I,N8),
    isbn10_check_digit(J,N9),
    { N9 is 11 - ((N0*10+N1*9+N2*8+N3*7+N4*6+N5*5+N6*4+N7*3+N8*2) mod 11) }.
