%% -*- coding: utf-8 -*-
:- begin_tests(lcs).
:- use_module(lcs).
:- encoding(utf8).

test(lcs_with_positions) :-
    atom_chars('axbyczpdq', X),
    atom_chars('abcaxbycz', Y),
    lcs_with_positions(X,Y,[6,[[a,0,0],[x,1,4],[b,2,5],[y,3,6],[c,4,7],[z,5,8]]]).

test(lcs) :- lcs([a,b,c],[a,c],[a,c]).
test(lcs) :- lcs([a,b,c],[a,b],[a,b]).
test(lcs) :- lcs([a,b,c],[b,c],[b,c]).
test(lcs) :- lcs([a,b,c],[a,b,c],[a,b,c]).
test(lcs) :- lcs([a,b,c],[x,y,z],[]).
test(lcs) :- lcs([a,b,c],[],[]).
test(lcs) :- lcs([a,x,b,y,c,z,p,d,q],[a,b,c,a,x,b,y,c,z],[a,x,b,y,c,z]).

test(fold) :- lcs:fold(plus,0,[1,2,3],6).
test(fold) :- lcs:fold(atom_concat,p,[ro,l,og],oglrop).

test(split_at) :- lcs:split_at([],0,[],[]).
test(split_at) :- lcs:split_at([a,b,c],1,[a],[b,c]).
test(split_at) :- lcs:split_at([a,b,c],3,[a,b,c],[]).

test(lcs_edit_list) :- lcs_edit_list([a,b,c,e,h,j,l,m,n,p],
                                     [b,c,d,e,f,j,k,l,m,r,s,t],
                                     [[[-,0,a]],
                                      [[+,2,d]],
                                      [[-,4,h],[+,4,f]],
                                      [[+,6,k]],
                                      [[-,8,n],[-,9,p],[+,9,r],[+,10,s],[+,11,t]]
                                     ]).
    
:- end_tests(lcs).
