%% -*- coding: utf-8 -*-
:- module(typo,
          [database/1,
           currval/2,
           nextval/2,
           user/2,
           reserved_nickname/1,
           bib/2,
           bookshelf/4,
           rep/4,shared_rep/1,recent_rep/1,
           syn/4,
           ack/4,
           review/4,shared_review/1,recent_review/1,review_history/3,
           share/1,unshare/1,
           updated_at/2,order_by_updated_at/4,
           nickname/2,
           password/2,
           mail_address/2,
           reserve_nickname/1,
           fetch_user/3,
           title/2,
           notify/2,
           caption/2,
           body/2,
           quote/2,
           fix/2,
           syns/2,acks/2,
           validate/2,
           read_data/3,
           read_data/4,
           declaration/3,
           yes/2,
           
           pages/3,
           page_number/3
           ]).
:- encoding(utf8).

:- initialization mutex_create(reserved_nickname).

database(currval/2).
database(user/2).
database(reserved_nickname/1).
database(bib/2).
database(bookshelf/4).
database(rep/4).
database(shared_rep/1).
database(recent_rep/1).
database(syn/4).
database(ack/4).
database(review/4).
database(shared_review/1).
database(recent_review/1).
database(review_history/3).

:- forall(database(X),dynamic(X)).

%% TABLE currval
currval(user,257).
currval(bib,15).
currval(bookshelf,30).
currval(rep,38).
currval(syn,41).
currval(ack,1).
currval(review,2).

nextval(X,Next) :-
    atom(X),
    retract(currval(X,N)),
    retractall(currval(X,_)),
    Next is N + 1,
    assert(currval(X,Next)).

%% TABLE users
user(1,[nickname(tabe),mail_address('tabe@fixedpoint.jp'),password('RZVbyvEKj053PD3hpeHT/RSLIvw=',[algorithm(sha1)])]).
user(2,[nickname(gmail),mail_address('tabe.fixedpoint@gmail.com'),password('cQERZeb0EW05Q6e174RGwC8Q6n8=',[algorithm(sha1)])]).
user(3,[nickname(znz),mail_address('znz@fixedpoint.jp')]).
user(4,[nickname(bluedwarf),mail_address('bluedwarf@fixedpoint.jp')]).

%% TABLE reserved_nicknames
reserved_nickname(tabe).
reserved_nickname(gmail).
reserved_nickname(znz).
reserved_nickname(bluedwarf).

%% TABLE bibs
bib(1,[title('Emacs Lisp リファレンスマニュアル'),isbn(13,'9784756134141'),isbn(10,'4756134149'),
       image([src('http://ecx.images-amazon.com/images/I/21EEkKNfI%2BL.jpg'),width(123),height(160)])]).
bib(2,[title('プログラミング作法'),isbn(10,'4756136494'),edition(1),impression(6),
       image([src('http://ecx.images-amazon.com/images/I/21B5DRRJF2L.jpg'),width(98),height(140)])]).
bib(3,[title('Statistics Hacks'),isbn(13,'9784873113357'),edition(1),
       image([src('http://ecx.images-amazon.com/images/I/21ByBS2-PFL.jpg'),height(160),width(114)])]).
bib(4,[title('Pthreads プログラミング'),isbn(13,'4900900664'),edition(1),impression(6),
       image([src('http://ecx.images-amazon.com/images/I/211PEB40TTL.jpg'),height(140),width(100)])]).
bib(5,[title('詳解UNIXプログラミング[新装版]'),isbn(10,'4894713195'),impression(6)]).
bib(6,[title('Prologへの入門'),isbn(13,'9784764901650'),impression(14)]).
bib(7,[title('プログラミング言語C 第2版 ANSI規格準拠'),isbn(10,'4320026926'),edition(2),impression(293)]).
bib(8,[title('C言語による最新アルゴリズム事典'),isbn(10,'4874084141'),impression(17)]).
bib(9,[title('SQLクイックリファレンス'),isbn(10,'4873110556'),impression(2)]).
bib(10,[title('UNIXネットワークプログラミング 第2版 Vol.1 ネットワークAPI: ソケットとXTI'),isbn(10,'4894712059'),impression(7)]).
bib(11,[title('UNIXネットワークプログラミング 第2版 Vol.2 IPC: プロセス間通信'),isbn(10,'4894712571'),impression(6)]).
bib(12,[title('プログラミング言語SCHEME'),isbn(10,'4894712261'),impression(2)]).
bib(13,[title('スタンダードテキスト OpenGL入門 やさしいコンピュータグラフィクス'),isbn(10,'4894714426'),impression(2)]).
bib(14,[title('Linkers & Loaders'),isbn(10,'4274064379'),impression(1)]). % オーム社
bib(15,[title('達人プログラマー - システム開発の職人から名匠への道 -'),isbn(10,'4894712741'),impression(15)]).

%% TABLE bookshelves
bookshelf(1,1,1,[notify(mail)]).
bookshelf(2,2,1,[notify(mail)]).
bookshelf(3,1,2,[]).
bookshelf(4,2,2,[]).
bookshelf(5,1,3,[]).
bookshelf(6,2,3,[]).
bookshelf(7,1,4,[]).
bookshelf(8,2,4,[]).
bookshelf(9,1,5,[]).
bookshelf(10,2,5,[]).
bookshelf(11,1,6,[]).
bookshelf(12,2,6,[]).
bookshelf(13,1,7,[]).
bookshelf(14,2,7,[]).
bookshelf(15,1,8,[]).
bookshelf(16,2,8,[]).
bookshelf(17,1,9,[]).
bookshelf(18,2,9,[]).
bookshelf(19,1,10,[]).
bookshelf(20,2,10,[]).
bookshelf(21,1,11,[]).
bookshelf(22,2,11,[]).
bookshelf(23,1,12,[]).
bookshelf(24,2,12,[]).
bookshelf(25,1,13,[]).
bookshelf(26,2,13,[]).
bookshelf(27,1,14,[]).
bookshelf(28,2,14,[]).
bookshelf(29,1,15,[]).
bookshelf(30,2,15,[]).

%% TABLE reps
rep(1,1,3,[caption('濁点が抜けている'),p(78),quote('スライドクラス')]).
rep(2,1,4,[caption('閉じ括弧が抜けている'),p(190),quote('シグナルアクション構造体（sigactionを')]).
rep(3,1,4,[caption('一文字違う'),p(190),quote('に従う、あういは')]).
rep(4,1,4,[caption('分が抜けている'),p(185),quote('これは9時15かもしれない')]).
rep(5,1,4,[caption('一文字違う'),p(133),quote('ラッパ-ルーチン')]).
rep(6,1,4,[caption('2文字違う'),p(88),quote('スレッドを持ってから状態')]).
rep(7,1,4,[caption('hが抜けている'),p(67),quote('この概念は同期（Syncronization）')]).
rep(8,1,4,[caption('例2-8の下から2, 3行目のインデントが深い'),p(55)]).
rep(9,1,4,[caption('例2-6の中の2行のインデントが深い'),p(49)]).
rep(10,1,4,[caption('添字がインクリメントされていない'),p(40),quote('pthread_create(……,stage1);\npthread_create(……,stage1);')]).
rep(11,1,4,[caption('区切りが抜けている'),p(36),quote('pthread_create(…pool_base);')]).
rep(12,1,4,[caption('のが重複している'),p(x),quote('こののテーマは速度である。'),updated_at(date(2008,2,10,1,2,26.1345,-32400,'JST',false)),created_at(date(2008,2,10,1,2,26.1345,-32400,'JST',false))]).
rep(13,1,1,[caption('入り口?'),p(787),quote('プログラムに少なくとも複数の入り口がある場合には、')]).
rep(14,1,5,[caption('否定形の誤り'),p(374),quote('メッセージの制御情報が「あり」のものは、ctlptr 引数が null でないか、ctlptr->len が 0 以上である。')]).
rep(15,1,5,[caption('可能性のみ'),p(378),quote('最大長より多く write すると、ストリームヘッドはデータを最大パケットサイズに分割し、最後のパケット長は最大長より短くなる。')]).
rep(16,1,5,[caption('漢字の間違い'),p(436),quote('システムVのこれらの3種類のIPCでは、内在する制約に出合うことがある。')]).
rep(17,1,6,[caption('cが抜けている'),p(36),quote('項がマッチする場合マッチは成功し(suceed)，')]).
rep(18,1,7,[caption('不要な空白'),p(7),quote('Cでは，hello , world と印字するためのプログラムは')]).
rep(19,1,7,[caption('コメント終端の間違い'),p(14),quote('を印字する；浮動小数点版 /*')]).
rep(20,1,7,[caption('ロン'),p(53),quote('第1章で輪じたように式')]).
rep(21,1,7,[caption('ブログラム'),p(230),quote('いかにマシンへの依存性が抑えられ，ブログラムのごくわずかの部分に限定され得るかを示す。')]).
rep(22,1,9,[caption('gが抜けている'),p(234),quote('SELECT LOWER(\'You Talkin To ME?\'), UPPER(\'you talking to me?!\');\n-> you talking to me?, YOU TALKIN TO ME?!')]).
rep(23,1,10,[caption('無駄なインデント'),p(64),quote('          struct sockaddr_un cli;')]).
rep(24,1,10,[caption('const 修飾子が抜けている?'),p(64),quote('int bind(int sockfd, struct sockaddr *myaddr, socklen_t addrlen);')]).
rep(25,1,10,[caption('off-by-one エラー'),p(148),quote('従って、ディスクリプタ0、1、2から始まり、maxfdp1 を含めたディスクリプタが検査対象となる。')]).
rep(26,1,10,[caption('図6.11の応答の列が要求になっている'),p(155),quote('要求2|要求3|要求4|要求5')]).
rep(27,1,10,[caption('2が抜けている'),p(326),quote('/*  番目の子プロセス */'),fix('/* 2番目の子プロセス */')]).
rep(28,1,10,[caption('1が抜けている'),p(471),quote('/*  バイトのヌルをパイプに書き込む */')]).
rep(29,1,10,[caption('デクリメントが "-" に'),p(-)]).
rep(30,1,10,[caption('デクリメントが "-" に(参考)'),p(600-602),quote('nconn-;')]).
rep(31,1,10,[caption('Berkeley-derived の訳語の不統一'),p(111),quote('(多くの Berkeley-derived のインプリメンテーションにおける')]).
rep(32,1,11,[caption('デクリメントが "-" に'),p(-)]).
rep(33,1,11,[caption('"*"が抜けている。'),p(105),quote('void (*sa_sigaction)(int, siginfo_t, void *);')]).
rep(34,1,11,[caption('")"がずれている'),p(441),quote('ごく簡単な場合を除いて何らかのプロセス間(あるいはスレッド間通信)を必要とする。')]).
rep(35,1,12,[caption('R5RS の 5 が抜けている'),p(130-135),quote('"Revised Report"')]).
rep(36,1,12,[caption('無駄な空白'),p(158),quote('パターン中の各識別子としては、リテラル(  literal)、')]).
rep(37,1,2,[caption('TEX'),p(224),quote('TEX')]).
rep(38,1,15,[caption('"い"が抜けている'),p(212),quote('いってらっしゃ')]).

%% TABLE syns
syn(1,1,1,[fix('スライドグラス')]).
syn(2,1,2,[fix('シグナルアクション構造体（sigaction）を')]).
syn(3,1,3,[fix('に従う、あるいは')]).
syn(4,1,4,[fix('これは9時15分かもしれない')]).
syn(5,1,5,[fix('ラッパールーチン')]).
syn(6,1,6,[fix('スレッドを持っている状態')]).
syn(7,1,7,[fix('この概念は同期（Synchronization）')]).
syn(10,1,10,[fix('pthread_create(……,stage1);\npthread_create(……,stage2);')]).
syn(11,1,11,[fix('pthread_create(…, pool_base);')]).
syn(12,1,12,[fix('このテーマは速度である。'),updated_at(date(2008,2,10,1,2,26.1345,-32400,'JST',false)),created_at(date(2008,2,10,1,2,26.1345,-32400,'JST',false))]).
syn(13,1,13,[fix('プログラムに少なくとも複数のエントリポイントがある場合には、')]).
syn(14,1,14,[fix('メッセージの制御情報が「あり」のものは、ctlptr 引数が null でなく、かつ ctlptr->len が 0 以上である。')]).
syn(15,1,15,[fix('最大長より多く write すると、ストリームヘッドはデータを最大パケットサイズに分割し、最後のパケット長は最大長より短くなる場合がある。')]).
syn(16,1,16,[fix('システムVのこれらの3種類のIPCでは、内在する制約に出会うことがある。')]).
syn(17,1,17,[fix('項がマッチする場合マッチは成功し(succeed)，')]).
syn(18,1,18,[fix('Cでは，hello, world と印字するためのプログラムは')]).
syn(19,1,19,[fix('を印字する；浮動小数点版 */')]).
syn(20,1,20,[fix('第1章で論じたように式')]).
syn(21,1,21,[fix('いかにマシンへの依存性が抑えられ，プログラムのごくわずかの部分に限定され得るかを示す。')]).
syn(22,1,22,[fix('SELECT LOWER(\'You Talking To ME?\'), UPPER(\'you talking to me?!\');\n-> you talking to me?, YOU TALKING TO ME?!')]).
syn(23,1,23,[fix('struct sockaddr_un cli;')]).
syn(24,1,24,[fix('int bind(int sockfd, const struct sockaddr *myaddr, socklen_t addrlen);')]).
syn(25,1,25,[fix('従って、ディスクリプタ0、1、2から始まり、maxfdp1 を含めないディスクリプタが検査対象となる。')]).
syn(26,1,26,[fix('応答2|応答3|応答4|応答5')]).
syn(27,1,27,[fix('/* 2番目の子プロセス */')]).
syn(28,1,28,[fix('/* 1バイトのヌルをパイプに書き込む */')]).
syn(30,1,30,[fix('nconn--;')]).
syn(31,1,31,[fix('(多くの Berkeley 派生のインプリメンテーションにおける')]).
syn(33,1,33,[fix('void (*sa_sigaction)(int, siginfo_t *, void *);')]).
syn(34,1,34,[fix('ごく簡単な場合を除いて何らかのプロセス間(あるいはスレッド間)通信を必要とする。')]).
syn(35,1,35,[fix('"Revised^5 Report"')]).
syn(36,1,36,[fix('パターン中の各識別子としては、リテラル(literal)、')]).
syn(37,1,37,[fix('TeX')]).
syn(38,1,38,[fix('いってらっしゃい')]).
syn(39,1,1,[body('http://www.gnu.org/software/emacs/elisp-manual/')]).
syn(40,1,257,[body('foo bar baz')]).
syn(41,2,1,[body('http://plan9.bell-labs.com/cm/cs/tpop/')]).

%% TABLE acks
ack(1,2,1,[body('確認しました。')]).

%% TABLE reviews
%% Id, UserId, BibId, Options
review(1,1,1,[body('"マイナモード"が気になる。')]).
review(2,1,2,[body('安い。')]).

review_history(1,1,[body('分厚い。')]).
review_history(1,1,[body('"マイナモード"が気になる。')]).
review_history(1,2,[body('安い。')]).

%% TABLE shared_* and recent_*
%% Each of them is asserta'ed and, thus, has newer records on top.
shared_rep(12).
recent_rep(12).
shared_review(1).
recent_review(1).

%% the SHARE model
share(Term) :-
    Term =.. [Name,Id|_],
    atom_concat('shared_',Name,Shared),
    atom_concat('recent_',Name,Recent),
    TS =.. [Shared,Id],
    TR =.. [Recent,Id],
    asserta(TS),
    asserta(TR).
unshare(Term) :-
    Term =.. [Name,Id|_],
    atom_concat('recent_',Name,Recent),
    atom_concat('shared_',Name,Shared),
    TR =.. [Recent,Id],
    TS =.. [Shared,Id],
    retractall(TR),
    retractall(TS).

%% predicates on each table.
updated_at(Options,Date) :- option(updated_at(Date),Options).
order_by_updated_at(asc,Delta,X,Y) :-
    updated_at(X,DX),
    updated_at(Y,DY),!,
    date_time_stamp(DX,TX),
    date_time_stamp(DY,TY),
    D is TX-TY,
    ( D < 0 -> Delta = '<'
    ; D > 0 -> Delta = '>'
    ; Delta = '='
    ).
order_by_updated_at(asc,>,X,_) :- updated_at(X,_),!.
order_by_updated_at(asc,<,_,Y) :- updated_at(Y,_),!.
order_by_updated_at(asc,=,_,_).
order_by_updated_at(desc,Delta,X,Y) :- order_by_updated_at(asc,Delta,Y,X).

%% predicates on users.
nickname(User,Name) :- option(nickname(Name),User).

password(User,Plain) :-
    memberchk(password(Base64,Option),User),
    sha_hash(Plain,Hash,Option),
    string_to_list(S,Hash),
    base64(S,Base64).

mail_address(User,MailAddress) :- option(mail_address(MailAddress),User).

reserve_nickname(Nickname) :-
    with_mutex(reserved_nickname,
               (\+ reserved_nickname(Nickname),
                assert(reserved_nickname(Nickname)))).

fetch_user(Name,Password,Id) :-
    user(Id,User),
    nickname(User,Name),!,
    password(User,Password).

%% predicates on bibs.
title(Bib,Title) :- option(title(Title),Bib).

%% predicates on bookshelves.
notify(Bookshelf,Notify) :- option(notify(Notify),Bookshelf).

%% predicates on reps.
caption(Rep,Caption) :- option(caption(Caption),Rep).
quote(Rep,Quote) :- option(quote(Quote),Rep).

%% predicates on syns.
fix(Syn,Fix) :- option(fix(Fix),Syn).

%% predicates on reviews.
body(Review,Body) :- option(body(Body),Review).

%% associcated predicates
syns(RepId,Syns) :- findall(syn(Id,UserId,RepId,Syn),syn(Id,UserId,RepId,Syn),Syns).
acks(SynId,Acks) :- findall(ack(Id,UserId,SynId,Ack),ack(Id,UserId,SynId,Ack),Acks).

%% VALIDATION
validate(nickname,Name) :-
    atom_chars(Name,Chars),
    length(Chars,L),L>2.
validate(password,Plain) :-
    atom_chars(Plain,Chars),
    length(Chars,L),L>3.
validate(yes,Value) :-
    atom_chars(Value,Chars),
    length(Chars,L),L>0.
validate(mail_address,Value) :-
    atom_chars(Value,Chars),
    length(Chars,L),L>3,
    concat_atom([_,_],'@',Value).

read_data(Key,Value,Data) :-
    read_data(Key,Value,Data,[]).
read_data(Key,Value,Data,[]) :-
    option(Key=Value,Data),
    validate(Key,Value).
read_data(Key,Value,Data,[repeat|Options]) :-
    atom_concat(Key,'_repeat',KeyOnceMore),
    option(KeyOnceMore=Value,Data),
    read_data(Key,Value,Data,Options).

declaration(Closure,Name,Options) :-
    atom_concat(Prefix,'_repeat',Name),!,
    declaration(Closure,Prefix,Options).
declaration(account,nickname,[optional(true),default('')]).
declaration(account,mail_address,[optional(true)]).
declaration(account,Name,[optional(true),default('')]) :-
    memberchk(Name,[password,new_password,current_password]),!.
declaration(bib,Name,[optional(true),default('')]) :-
    memberchk(Name,[title,edition,impression]),!.
declaration(rep,caption,[optional(true),default('')]).
declaration(rep,p,[optional(true),default('')]).
declaration(rep,quote,[optional(true),default('')]).
declaration(_,body,[optional(true),default('')]) :- !.
declaration(_,fix,[optional(true),default('')]) :- !.
declaration(_,isbn,[optional(true),default(''),length >= 10]) :- !.
declaration(_,id,[integer]) :- !.
declaration(_,ticket,[length >= 10]) :- !.
declaration(_,yes,[optional(true),oneof(['Yes','yes','y']),default(false)]) :- !.
declaration(_,no,[optional(true),oneof(['No','no','n']),default(false)]) :- !.
declaration(_,force,[optional(true),oneof([true,false]),default(false)]) :- !.

yes(Yes,false) :- memberchk(Yes,['Yes','yes','y']).

%% parsers by DCG are expected to be used widely.

digits([D|Rest]) -->
    digit(D),!,
    digits(Rest).
digits([]) --> [].
digit(D) -->
    [D],
    { char_type(D,digit) }.

pages(-) --> ['-'],!.
pages(Start-End) -->
    page_number(Start),
    page_trailer(End).
page_trailer(ff) --> ['f','f'],!.
page_trailer(f) --> ['f'],!.
page_trailer(Page) --> [-],page_number(Page).

page_number(Page) -->
    digit(D),
    digits(Rest),
    { number_chars(Page,[D|Rest]) }.
