%% -*- coding: utf-8 -*-
:- module(typo_dbi,[typo_dbi_insert/1,typo_dbi_delete/1,typo_dbi_update/1,
                    typo_dbi_assert/1]).
:- use_module(library(socket)).
:- use_module(typo_ipc).
:- use_module(typo_sql).
:- encoding(utf8).

typo_dbi_port(6543).

typo_dbi_call(Sexp) :-
    typo_dbi_port(Port),
    typo_ipc_call(Port,Sexp,true).

typo_dbi_insert(Term) :- with_output_to(atom(Sexp),typo_sql_insert(Term)),typo_dbi_call(Sexp).
typo_dbi_delete(Term) :- with_output_to(atom(Sexp),typo_sql_delete(Term)),typo_dbi_call(Sexp).
typo_dbi_update(Term) :- with_output_to(atom(Sexp),typo_sql_update(Term)),typo_dbi_call(Sexp).

typo_dbi_assert(Term) :-
    typo_dbi_insert(Term),
    assert(typo:Term).
