%% -*- coding: utf-8 -*-
:- module(typo_interaction,[typo_interaction/4]).
:- use_module(isbn).
:- use_module(typo_aws).
:- use_module(typo).
:- encoding(utf8).

typo_interaction(put_on,Input,retry,[message('Hint: try to specify the one with its ISBN.')|Input]) :-
    option(title(''),Input),
    option(isbn(''),Input),!.
typo_interaction(put_on,Input,retry,Output) :-
    option(title(Title),Input),
    option(isbn(ISBN),Input),
    atom_chars(ISBN,LIST_X),
    phrase(isbn(_,L_X),LIST_X),
    concat_atom(L_X,ISBN_X),
    ( isbn_to_title(ISBN_X,title(T)),
      isbn_to_image(ISBN_X,image(Image)) ->
      ( Title == '' ->
        merge_options([image(Image),isbn(ISBN_X),message('This one?'),title(T)],Input,Output)
      ; Title \== T,
        \+ option(force(true),Input) ->
        merge_options([force(true),image(Image),isbn(ISBN_X),message(['Amazon calls this one `',T,'\'; OK?']),title(Title)],Input,Output)
      ; fail
      )
    ; Title == '' ->
      merge_options([message(['Amazon does not know ISBN `',ISBN_X,'\'. Please keep ISBN blank if you are sure.']),isbn('')],Input,Output)
    ),!.
typo_interaction(put_on,Input,next,Output) :-
    option(title(Title),Input),
    option(isbn(ISBN),Input),
    option(edition(Edition),Input),
    option(impression(Impression),Input),
    atom_chars(ISBN,LIST_X),
    phrase(isbn(N_X,L_X),LIST_X),
    concat_atom(L_X,ISBN_X),
    ( isbn_to_image(ISBN_X,image(Image)) ->
      Output = [edition(Edition),image(Image),impression(Impression),isbn(N_X,ISBN_X),title(Title)]
    ; Output = [edition(Edition),impression(Impression),isbn(N_X,ISBN_X),title(Title)]
    ),!.
typo_interaction(put_on,Input,next,[edition(Edition),impression(Impression),title(Title)]) :-
    option(title(Title),Input),
    option(edition(Edition),Input),
    option(impression(Impression),Input),!.
