%% -*- coding: utf-8 -*-
:- module(typo_mail,[mail_sender/1,mail_template/3]).
:- use_module(typo_url).
:- encoding(utf8).

mail_sender('typo@fixedpoint.jp').

mail_subject_header('typo -- ').

mail_subject(Line,Subject) :-
    is_list(Line),!,
    concat_atom(Line,L),
    mail_subject(L,Subject).
mail_subject(Line,Subject) :-
    mail_subject_header(Header),
    atom_concat(Header,Line,Subject).

mail_body_footer('-- typo.fixedpoint.jp').

mail_body(Lines,Body) :-
    mail_body_footer(Footer),
    append(Lines,['\n\n',Footer],Extended),
    concat_atom(Extended,Body).

mail_template(notify(Name,Id,Nickname),Subject,Body) :-
    typo_host(Host),
    handler(Path,rep),
    parse_url(URL,[protocol(http),host(Host),path(Path),search([id = Id])]),
    mail_subject(['New ',Name,' has come'],Subject),
    mail_body(['Hi, ',Nickname,'\n',
               '\n',
               'New ',Name,' has come: ',URL],
              Body),
    !.
mail_template(welcome(Name,Ticket),Subject,Body) :-
    typo_host(Host),
    handler(Path,welcome),
    parse_url(URL,[protocol(http),host(Host),path(Path),search([ticket = Ticket])]),
    mail_subject(['Welcome to ',Host],Subject),
    mail_body(['Hi, ',Name,'\n',
               '\n',
               'We thank your request for joining us.\n',
               'You can confirm it and be logged in typo by getting the following URL with your web browser.\n',
               'Enjoy!\n',
               '\n',
               URL],
              Body),
    !.
