%% -*- coding: utf-8 -*-
:- encoding(utf8).
:- begin_tests(typo_sql).
:- use_module(typo_sql).

test(typo_sql_insert) :-
    T = user(1,[nickname(tabe),mail_address('tabe@fixedpoint.jp'),password('RZVbyvEKj053PD3hpeHT/RSLIvw=',[algorithm(sha1)])]),
    S = '(typo-sql-insert "users" :id 1 :nickname "tabe" :mail_address "tabe@fixedpoint.jp" :password "RZVbyvEKj053PD3hpeHT/RSLIvw=" :password_algorithm "sha1")',
    with_output_to(atom(A),typo_sql_insert(T)),
    with_output_to(atom(A),write(S)).
test(typo_sql_insert) :-
    forall(typo:user(Id,Options),with_output_to(atom(_),typo_sql_insert(user(Id,Options)))).
test(typo_sql_insert) :-
    T = bib(1,[title('Emacs Lisp リファレンスマニュアル'),isbn(13,'9784756134141'),isbn(10,'4756134149'),
               image([src('http://ecx.images-amazon.com/images/I/21EEkKNfI%2BL.jpg'),width(123),height(160)])]),
    S = '(typo-sql-insert "bibs" :id 1 :title "Emacs Lisp リファレンスマニュアル" :isbn10 "4756134149" :isbn13 "9784756134141" :image_src "http://ecx.images-amazon.com/images/I/21EEkKNfI%2BL.jpg" :image_width 123 :image_height 160)',
    with_output_to(atom(A),typo_sql_insert(T)),
    with_output_to(atom(A),write(S)).
test(typo_sql_insert) :-
    forall(typo:bib(Id,Options),with_output_to(atom(_),typo_sql_insert(bib(Id,Options)))).
test(typo_sql_insert) :-
    T = bookshelf(1,1,1,[notify(mail)]),
    S = '(typo-sql-insert "bookshelves" :id 1 :user_id 1 :bib_id 1 :notify "mail")',
    with_output_to(atom(A),typo_sql_insert(T)),
    with_output_to(atom(A),write(S)).
test(typo_sql_insert) :-
    forall(typo:bookshelf(Id,UserId,BibId,Options),with_output_to(atom(_),typo_sql_insert(bookshelf(Id,UserId,BibId,Options)))).
test(typo_sql_insert) :-
    forall(typo:rep(Id,UserId,BibId,Options),with_output_to(atom(_),typo_sql_insert(rep(Id,UserId,BibId,Options)))).

test(typo_sql_delete) :-
    T = user(1),
    S = '(typo-sql-delete "users" 1)',
    with_output_to(atom(A),typo_sql_delete(T)),
    with_output_to(atom(A),write(S)).

test(typo_sql_update) :-
    T = bib(1,[title('Emacs Lisp リファレンスマニュアル'),isbn(13,'9784756134141'),isbn(10,'4756134149'),
               image([src('http://ecx.images-amazon.com/images/I/21EEkKNfI%2BL.jpg'),width(123),height(160)])]),
    S = '(typo-sql-update "bibs" ( :title "Emacs Lisp リファレンスマニュアル" :isbn10 "4756134149" :isbn13 "9784756134141" :image_src "http://ecx.images-amazon.com/images/I/21EEkKNfI%2BL.jpg" :image_width 123 :image_height 160) 1)',
    with_output_to(atom(A),typo_sql_update(T)),
    with_output_to(atom(A),write(S)).

:- end_tests(typo_sql).
