%% -*- coding: utf-8 -*-
:- module(typo_url,[typo_host/1,handler/2,css/1,js/1,image/1,path/3]).
:- encoding(utf8).

typo_host('typo.fixedpoint.jp').

%% handler
handler('/',root).
handler('/join',join).
handler('/welcome',welcome).
handler('/login',login).
handler('/logout',logout).
handler('/home',home).
handler('/home/bookshelf',bookshelf).
handler('/home/bookshelf/put/on',put_on).
handler('/home/bookshelf/put/off',put_off).
handler('/home/bookshelf/write/review',write_review).
handler('/home/bookshelf/share/review',share_review).
handler('/home/desk',desk).
handler('/home/desk/create/rep',create_rep).
handler('/home/desk/share/rep',share_rep).
handler('/home/desk/send/syn',send_syn).
handler('/home/desk/send/ack',send_ack).
handler('/bib',bib).
handler('/rep',rep).
handler('/home/window',window).
handler('/home/window/account',account).
handler('/home/window/account/modify/mail/address',modify_mail_address).
handler('/home/window/account/modify/password',modify_password).
handler('/leave',leave).

css('typo.css').

js('typo.js').
js('builder.js').
js('controls.js').
js('dragdrop.js').
js('effects.js').
js('prototype.js').
js('scriptaculous.js').
js('slider.js').

image('typo.png').
image('home.png').
image('bookshelf.png').
image('desk.png').
image('share.png').

path(Closure,Search,Path) :-
    handler(Location,Closure),!,
    parse_url_search(List,Search),
    atom_codes(Atom,List),
    concat_atom([Location,'?',Atom],Path).
