;;
;; Test cgi
;;

(use gauche.test)
(use www.cgi.test)

(test-start "*.cgi")

(test-section "io.cgi")

(use file.util)

(define-syntax test*-cgi-script-with-parameters/headers/body
  (syntax-rules ()
    ((_ script (e p h b) ...)
     (begin
       (call-with-values
           (cut run-cgi-script->string "./io.cgi" :environment 'e :parameters 'p)
         (lambda (headers body)
           (test* "io.cgi(headers)" 'h headers)
           (test* "io.cgi(body)" (file->string b) body)))
       ...))))

(test*-cgi-script-with-parameters/headers/body
 "./io.cgi"

 ;; nothing specified
 (()
  ()
  (("location" "/"))
  "/dev/null")

 (()
  ((foo . "bar"))
  (("location" "/"))
  "/dev/null")

 ;; /join
 (((PATH_INFO . "/join"))
  ()
  (("content-type" "text/html"))
  "files/io.0.html")

 ;; /rep
 (((PATH_INFO . "/rep"))
  ()
  (("content-type" "text/html"))
  "files/io.0.html")

 ;; no such path
 (((PATH_INFO . "/no_such_path"))
  ()
  (("location" "/"))
  "/dev/null")

 )

(test-end)
