;;
;; Test typo.dbi
;;

(use gauche.test)

(test-start "typo.dbi")

(use typo.dbi)
(test-module 'typo.dbi)

(use dbi)
(use gauche.collection)

(define conn #f)
(dynamic-wind
    (lambda ()
      (set! conn (dbi-connect "dbi:pg:dbname=typo;host=localhost;port=5432" :username "tabe"))
      (typo-dbi-create-table conn "passwords" :body '(<string> :null #f) :encrypted '(<boolean> :null #t))
      )

    (lambda ()
      (test-section "typo-dbi-select")

      (let ((result (typo-dbi-select conn "passwords" '())))
        (test* "typo-dbi-select" #t (is-a? result <relation>))
        (test* "typo-dbi-select" #t (is-a? result <collection>))
        (test* "typo-dbi-select" #t (number? (size-of result)))
        (typo-dbi-close result)
        )

      (test-section "typo-dbi-insert")

      (let ((result (typo-dbi-insert conn "passwords" :id 100 :body "foo" :encrypted #f)))
        (typo-dbi-close result)
        (test* "typo-dbi-select" 1 (typo-dbi-count conn "passwords"))
        )

      (test-section "typo-dbi-update")

      (let ((result (typo-dbi-update conn "passwords" '(:body "bar") :body "foo")))
        (typo-dbi-close result)
        (test* "typo-dbi-update" 1 (typo-dbi-count conn "passwords" :body "bar" :encrypted #f))
        )

      (test-section "typo-dbi-delete")

      (let ((result (typo-dbi-delete conn "passwords" :body "bar")))
        (typo-dbi-close result)
        (test* "typo-dbi-delete" 0 (typo-dbi-count conn "passwords" :body "bar"))
        )
      )
    
    (lambda ()
      (typo-dbi-drop-table conn "passwords")
      (dbi-close conn)))

(test-end)
