;;
;; Test typo.html
;;

(use gauche.test)

(test-start "typo.html")
(use typo.html)
(test-module 'typo.html)

(use srfi-19)
(use text.tree)

(test-section "*-select")

(test* "year-select"
       "<select name=\"birthdate_y\"><option value=\"2005\">2005</option\n><option value=\"2006\">2006</option\n><option value=\"2007\">2007</option\n><option value=\"2008\" selected=\"2008\">2008</option\n><option value=\"2009\">2009</option\n></select\n>"
       (tree->string (year-select "birthdate_y" :date (make-date 0 0 0 0 31 10 2007 9) :selected 2008)))

(test* "month-select"
       "<select name=\"birthdate_m\"><option value=\"1\">01</option\n><option value=\"2\">02</option\n><option value=\"3\">03</option\n><option value=\"4\">04</option\n><option value=\"5\">05</option\n><option value=\"6\">06</option\n><option value=\"7\">07</option\n><option value=\"8\">08</option\n><option value=\"9\">09</option\n><option value=\"10\">10</option\n><option value=\"11\" selected=\"11\">11</option\n><option value=\"12\">12</option\n></select\n>"
       (tree->string (month-select "birthdate_m" :date (make-date 0 0 0 0 1 11 2007 9))))

(test* "day-select"
"<select name=\"birthdate_d\"><option value=\"1\">01</option\n><option value=\"2\" selected=\"2\">02</option\n><option value=\"3\">03</option\n><option value=\"4\">04</option\n><option value=\"5\">05</option\n><option value=\"6\">06</option\n><option value=\"7\">07</option\n><option value=\"8\">08</option\n><option value=\"9\">09</option\n><option value=\"10\">10</option\n><option value=\"11\">11</option\n><option value=\"12\">12</option\n><option value=\"13\">13</option\n><option value=\"14\">14</option\n><option value=\"15\">15</option\n><option value=\"16\">16</option\n><option value=\"17\">17</option\n><option value=\"18\">18</option\n><option value=\"19\">19</option\n><option value=\"20\">20</option\n><option value=\"21\">21</option\n><option value=\"22\">22</option\n><option value=\"23\">23</option\n><option value=\"24\">24</option\n><option value=\"25\">25</option\n><option value=\"26\">26</option\n><option value=\"27\">27</option\n><option value=\"28\">28</option\n><option value=\"29\">29</option\n><option value=\"30\">30</option\n><option value=\"31\">31</option\n></select\n>"
       (tree->string (day-select "birthdate_d" :date (make-date 0 0 0 0 2 11 2007 9))))

(test* "hour-select"
"<select name=\"h\"><option value=\"0\" selected=\"0\">00</option\n><option value=\"1\">01</option\n><option value=\"2\">02</option\n><option value=\"3\">03</option\n><option value=\"4\">04</option\n><option value=\"5\">05</option\n><option value=\"6\">06</option\n><option value=\"7\">07</option\n><option value=\"8\">08</option\n><option value=\"9\">09</option\n><option value=\"10\">10</option\n><option value=\"11\">11</option\n><option value=\"12\">12</option\n><option value=\"13\">13</option\n><option value=\"14\">14</option\n><option value=\"15\">15</option\n><option value=\"16\">16</option\n><option value=\"17\">17</option\n><option value=\"18\">18</option\n><option value=\"19\">19</option\n><option value=\"20\">20</option\n><option value=\"21\">21</option\n><option value=\"22\">22</option\n><option value=\"23\">23</option\n></select\n>"
       (tree->string (hour-select "h" :date (make-date 0 0 0 23 31 10 2007 9) :selected 0)))

(test* "minute-select"
       "<select name=\"m\"><option value=\"0\" selected=\"0\">00</option\n><option value=\"1\">01</option\n><option value=\"2\">02</option\n><option value=\"3\">03</option\n><option value=\"4\">04</option\n><option value=\"5\">05</option\n><option value=\"6\">06</option\n><option value=\"7\">07</option\n><option value=\"8\">08</option\n><option value=\"9\">09</option\n><option value=\"10\">10</option\n><option value=\"11\">11</option\n><option value=\"12\">12</option\n><option value=\"13\">13</option\n><option value=\"14\">14</option\n><option value=\"15\">15</option\n><option value=\"16\">16</option\n><option value=\"17\">17</option\n><option value=\"18\">18</option\n><option value=\"19\">19</option\n><option value=\"20\">20</option\n><option value=\"21\">21</option\n><option value=\"22\">22</option\n><option value=\"23\">23</option\n><option value=\"24\">24</option\n><option value=\"25\">25</option\n><option value=\"26\">26</option\n><option value=\"27\">27</option\n><option value=\"28\">28</option\n><option value=\"29\">29</option\n><option value=\"30\">30</option\n><option value=\"31\">31</option\n><option value=\"32\">32</option\n><option value=\"33\">33</option\n><option value=\"34\">34</option\n><option value=\"35\">35</option\n><option value=\"36\">36</option\n><option value=\"37\">37</option\n><option value=\"38\">38</option\n><option value=\"39\">39</option\n><option value=\"40\">40</option\n><option value=\"41\">41</option\n><option value=\"42\">42</option\n><option value=\"43\">43</option\n><option value=\"44\">44</option\n><option value=\"45\">45</option\n><option value=\"46\">46</option\n><option value=\"47\">47</option\n><option value=\"48\">48</option\n><option value=\"49\">49</option\n><option value=\"50\">50</option\n><option value=\"51\">51</option\n><option value=\"52\">52</option\n><option value=\"53\">53</option\n><option value=\"54\">54</option\n><option value=\"55\">55</option\n><option value=\"56\">56</option\n><option value=\"57\">57</option\n><option value=\"58\">58</option\n><option value=\"59\">59</option\n></select\n>"
       (tree->string (minute-select "m" :date (make-date 0 0 23 0 1 1 1970 9) :selected 0)))

(test-end)
