;;
;; Test swi-prolog
;;

(use gauche.test)

(test-start "swi-prolog")
(use lang.swi-prolog)

(test-section "x->term")

(test* "x->term" 'true (x->term #t))
(test* "x->term" 'false (x->term #f))

(test* "x->term" 100 (x->term 100))
(test* "x->term" 3.5 (x->term 3.5))

(test* "x->term" "''" (x->term ""))
(test* "x->term" "'\\\\'" (x->term "\\"))
(test* "x->term" "'\\''" (x->term "'"))
(test* "x->term" "'\\f'" (x->term "\f"))
(test* "x->term" "'\\n'" (x->term "\n"))
(test* "x->term" "'\\r'" (x->term "\r"))
(test* "x->term" "'\\t'" (x->term "\t"))

(test-section "alist->term")
(use text.tree)
(use util.list)

(test* "hash-table->term"
       "[scheme('スキーム'),prolog('プロログ'),c('シー'),d('ディー')]"
       (tree->string
        (alist->term
         '((scheme . "スキーム")
           (prolog . "プロログ")
           (c . "シー")
           (d . "ディー")
           ))))
       
(test-end)
